import 'package:auto_route/auto_route.dart';
import 'package:island/route.gr.dart';

@AutoRouterConfig(replaceInRouteName: 'Screen|Page,Route')
class AppRouter extends RootStackRouter {
  @override
  RouteType get defaultRouteType => RouteType.adaptive();

  @override
  List<AutoRoute> get routes => [
    RedirectRoute(path: '/', redirectTo: '/explore'),
    AutoRoute(page: ExploreRoute.page, path: '/explore'),
    AutoRoute(
      page: AccountShellRoute.page,
      path: '/account',
      children: [
        AutoRoute(page: WalletRoute.page, path: 'wallet'),
        AutoRoute(page: RelationshipRoute.page, path: 'relationships'),
        AutoRoute(page: AccountRoute.page, path: ''),
        AutoRoute(page: AccountSettingsRoute.page, path: 'settings'),
        AutoRoute(page: AccountProfileRoute.page, path: ':name'),
        AutoRoute(page: PublisherProfileRoute.page, path: ':name/calendar'),
        AutoRoute(page: MyselfEventCalendarRoute.page, path: 'me/calendar'),
        AutoRoute(page: UpdateProfileRoute.page, path: 'me/update'),
        AutoRoute(page: ManagedPublisherRoute.page, path: 'me/publishers'),
      ],
    ),
    AutoRoute(page: RealmListRoute.page, path: '/realms'),
    AutoRoute(
      page: ChatShellRoute.page,
      path: '/chat',
      children: [
        AutoRoute(page: ChatListRoute.page, path: ''),
        AutoRoute(page: ChatRoomRoute.page, path: ':id'),
        AutoRoute(page: NewChatRoute.page, path: 'new'),
        AutoRoute(page: EditChatRoute.page, path: ':id/edit'),
        AutoRoute(page: ChatDetailRoute.page, path: ':id/detail'),
      ],
    ),
    AutoRoute(page: SettingsRoute.page, path: '/settings'),
    AutoRoute(page: LoginRoute.page, path: '/auth/login'),
    AutoRoute(page: CreateAccountRoute.page, path: '/auth/create-account'),
    AutoRoute(page: AccountSettingsRoute.page, path: '/account/settings'),
    AutoRoute(page: PostComposeRoute.page, path: '/posts/compose'),
    AutoRoute(page: PostDetailRoute.page, path: '/posts/:id'),
    AutoRoute(page: PostEditRoute.page, path: '/posts/:id/edit'),
    AutoRoute(page: NewRealmRoute.page, path: '/realms/new'),
    AutoRoute(page: RealmDetailRoute.page, path: '/realms/:slug'),
    AutoRoute(page: EditRealmRoute.page, path: '/realms/:slug/edit'),
    AutoRoute(page: CreatorHubRoute.page, path: '/creators'),
    AutoRoute(page: StickersRoute.page, path: '/creators/:name/stickers'),
    AutoRoute(
      page: NewStickerPacksRoute.page,
      path: '/creators/:name/stickers/new',
    ),
    AutoRoute(
      page: EditStickerPacksRoute.page,
      path: '/creators/:name/stickers/:packId/edit',
    ),
    AutoRoute(
      page: StickerPackDetailRoute.page,
      path: '/creators/:name/stickers/:packId',
    ),
    AutoRoute(
      page: NewStickersRoute.page,
      path: '/creators/:name/stickers/new',
    ),
    AutoRoute(
      page: EditStickersRoute.page,
      path: '/creators/:name/stickers/:id/edit',
    ),
  ];
}
